<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>


<%@ page contentType="text/html" pageEncoding="UTF-8" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.common.to.AddressEndpointData" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="org.apache.synapse.endpoints.*" %>
<%@ page import="org.apache.synapse.config.xml.endpoints.*" %>
<%@ page import="org.wso2.carbon.endpoint.ui.util.EndpointConfigurationHelper" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<jsp:include page="../resources/resources-i18n-ajaxprocessor.jsp"/>

<link type="text/css" rel="stylesheet" href="css/menu.css"/>
<link type="text/css" rel="stylesheet" href="css/style.css"/>

<!-- Dependencies -->
<script type="text/javascript" src="../yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="../yui/build/container/container_core-min.js"></script>

<!-- Connection handling lib -->
<script type="text/javascript" src="../yui/build/yahoo/yahoo-min.js"></script>
<script type="text/javascript" src="../yui/build/event/event-min.js"></script>
<script type="text/javascript" src="../yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="../resources/js/resource_util.js"></script>
<script type="text/javascript" src="../yui/build/utilities/utilities.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<script type="text/javascript" src="../sequences/js/registry-browser.js"></script>
<!-- Source File -->

<script type="text/javascript" src="../yui/build/menu/menu-min.js"></script>

<link type="text/css" rel="stylesheet" href="css/style.css"/>
<link rel="stylesheet" type="text/css" href="../resources/css/registry.css"/>

<fmt:bundle basename="org.wso2.carbon.endpoint.ui.i18n.Resources">
<carbon:jsi18n
        resourceBundle="org.wso2.carbon.endpoint.ui.i18n.Resources"
        request="<%=request%>"/>
<carbon:breadcrumb
        label="address.endpoint"
        resourceBundle="org.wso2.carbon.endpoint.ui.i18n.Resources"
        topPage="false"
        request="<%=request%>"/>
<%
    AddressEndpointData addressEpData = null;
    String[] formatOptions = {"soap11", "soap12", "POX", "REST", "GET", "leave-as-is"};
    String[] optimizeOptions = {"SWA", "MTOM", "leave-as-is"};
    String[] actionOptions = {"neverTimeout", "discardMessage", "executeFaultSequence"};

    String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().
                    getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient adminClient = new EndpointAdminClient(cookie, url, configContext);

    String endpointName = request.getParameter("endpointName");
    String endpointAction = request.getParameter("endpointAction");
    String design = request.getParameter("design");

    String endpointMode = null; // this holds an annonymos endpoint which can come through proxy and send mediator
    String anonymouseOriginator = null;
    boolean isAnonymous = false;
    String anonymousEndpointXML = null;
    endpointMode = (String) session.getAttribute("epMode");
    if (endpointMode != null && "anon".equals(endpointMode)) {
        isAnonymous = true;
    }

    // coming through index.jsp by clicking the 'edit' link
    if (endpointAction != null && !"".equals(endpointAction) && endpointAction.equals("edit")) {
        session.setAttribute("edit" + endpointName, "edit"); // uses when saving the endpoint
        try {
            addressEpData = adminClient.getAddressEndpoint(endpointName);
        } catch (Exception e) {
            String msg = "Unable to get Address Endpoint data: " + e.getMessage();
            CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
        }

    } else if (design != null && !"".equals(design)) {
        // coming through source view using switchToDesign
        OMElement element = null;
        try {
            design = design.replaceAll("\\s\\s+|\\n|\\r", ""); // remove the pretty printing from the string
            design = EndpointConfigurationHelper.getValidStringXMlStringForAMP(design); // convert into a valid XML string, when a JMS endpoint is used etc..
            element = AXIOMUtil.stringToOM(design);
            AddressEndpoint addressEp = (AddressEndpoint) EndpointFactory.getEndpointFromElement(element, false);
            addressEpData = EndpointConfigurationHelper.getAddressEpFromSynEp(addressEp, session, isAnonymous);
        } catch (XMLStreamException e) {
            String msg = "Unable to get Address Endpoint data: " + e.getMessage();
            CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
        } catch (Exception e) {
            String msg = "Unable to get Address Endpoint data: " + e.getMessage();
            CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
        }

    } else if (isAnonymous) {
        // coming through using either send mediator or proxy services by adding an annonymous endpoint
        // we are in anonymous mode
        anonymouseOriginator = (String) session.getAttribute("anonOriginator");
        anonymousEndpointXML = (String) session.getAttribute("anonEpXML");
        if (anonymousEndpointXML != null && !"".equals(anonymousEndpointXML)) {
            // if a user is here that mean user is trying to edit an existing anoymous endpoint
            try {
                addressEpData = EndpointAdminClient.
                        getAddressEndpointData(anonymousEndpointXML);
            } catch (XMLStreamException e) {
                session.removeAttribute("anonEpXML");
%>
<script type="text/javascript">
    CARBON.showErrorDialog("Unable to create endpoint with given data");
    window.location.href = "addressEndpoint.jsp";
</script>
<%
            }
        }
    }

    String addressEpName = "";
    String endpointAddress = "";
    String validAddressURL = "";
    boolean isPox = false, isRest = false, isSoap11 = false, isSoap12 = false , isGet = false;
    boolean isformatDefault = true;
    boolean isSWA = false, isMTOM = false, isOptimizeDefault = true;
    String errorCode = "";
    long suspendDurationOnFailure = 0;
    long maxDuration = 0;
    double factor = 1.0; // default value
    String timeOutErrorCode = "";
    int retryTimeOut = 0;
    int retryDelayTimeOut = 0;
    boolean isNeverTimeout = true, isDiscardMessage = false, isFaultSequence = false;
    long actionDuration = 0;
    boolean isEnableAddressing = false;
    boolean isSepListener = false;
    boolean isEnableWSSec = false;
    String secPolicy = "";
    boolean isEnableRM = false;
    String rmPolicy = "";

    if (addressEpData != null) {
        // Endpoint Name
        if (addressEpData.getEpName() != null) {
            addressEpName = addressEpData.getEpName();
        }

        // Endpoint Address
        if (addressEpData.getAddress() != null) {
            endpointAddress = addressEpData.getAddress();
            validAddressURL = EndpointConfigurationHelper.getValidXMLString(endpointAddress);
        }

        // Format string
        if (addressEpData.isPox()) {
            isPox = true;
        } else if (addressEpData.isRest()) {
            isRest = true;
        } else if (addressEpData.isSoap11()) {
            isSoap11 = true;
        } else if (addressEpData.isSoap12()) {
            isSoap12 = true;
        } else if (addressEpData.isGet()) {
            isGet = true;
        } else {
            isformatDefault = true;
        }
        if (isPox || isRest || isSoap11 || isSoap12 || isGet) {
            isformatDefault = false;
        }

        // Optimize string
        if (addressEpData.isMtom()) {
            isMTOM = true;
        } else if (addressEpData.isSwa()) {
            isSWA = true;
        } else {
            isOptimizeDefault = true;
        }
        if (isMTOM || isSWA) {
            isOptimizeDefault = false;
        }

        // Error codes
        if (addressEpData.getErrorCodes() != null) {
            errorCode = addressEpData.getErrorCodes().trim();
        }

        // Initial duration
        if (addressEpData.getSuspendDurationOnFailure() >= 0) {
            suspendDurationOnFailure = addressEpData.getSuspendDurationOnFailure();
        }

        // Max duration
        if (0 <= addressEpData.getMaxSusDuration() && addressEpData.getMaxSusDuration() < Long.MAX_VALUE) {
            maxDuration = addressEpData.getMaxSusDuration();
        }

        // Factor
        if (0 <= addressEpData.getSusProgFactor() && addressEpData.getSusProgFactor() >= 0.0) {
            factor = addressEpData.getSusProgFactor();
        }

        // TimeOut error code
        if (addressEpData.getTimdedOutErrorCodes() != null) {
            timeOutErrorCode = addressEpData.getTimdedOutErrorCodes().trim();
        }

        // Retry time out
        if (addressEpData.getRetryTimeout() > 0) {
            retryTimeOut = addressEpData.getRetryTimeout();
        }

        // Retry delay timeout
        if (addressEpData.getRetryDelay() > 0) {
            retryDelayTimeOut = addressEpData.getRetryDelay();
        }

        // Action
        if (addressEpData.getTimeoutAct() == 100) { // TODO-remove magic number
            isNeverTimeout = true;
        } else if (addressEpData.getTimeoutAct() == 101) { // TODO-remove magic number
            isDiscardMessage = true;
            actionDuration = addressEpData.getTimeoutActionDur();
        } else {
            isFaultSequence = true;
            actionDuration = addressEpData.getTimeoutActionDur();
        }

        if (isDiscardMessage || isFaultSequence) {
            isNeverTimeout = false;
        }

        // Enable WS-Addressing?
        if (addressEpData.isWsadd()) {
            isEnableAddressing = true;
        }

        // Use seperate listener ?
        if (addressEpData.isSepList()) {
            isSepListener = true;
        }

        // Enable WS-Sec?
        if (addressEpData.isWssec()) {
            isEnableWSSec = true;
            // Sec. policy
            if (addressEpData.getSecPolKey() != null) {
                secPolicy = addressEpData.getSecPolKey();
            }
        }

        // Enable rm ?
        if (addressEpData.isWsrm()) {
            isEnableRM = true;
            // RM. policy
            if (addressEpData.getRmPolKey() != null) {
                rmPolicy = addressEpData.getRmPolKey();
            }
        }
    }
%>

<script type="text/javascript" src="js/addressEndpoint.js"></script>
<script type="text/javascript" src="js/endpoint-util.js"></script>
<script type="text/javascript">

    // invoke when saving addressEndpoint data
    function submitEndpointData(isAnonymous) {
        if (!isValidAddressORWSDLEndpoint(isAnonymous, 'address')) {
            return false;
        }
        document.addressEndpointForm.action = 'saveEndpoint.jsp?endpointType=addressEndpoint';
        document.addressEndpointForm.submit();
        return true;
    }

    function submitDynamicEndpointData() {
        if (!isValidAddressORWSDLEndpoint(true, 'address')) {
            return false;
        }

        var key = document.getElementById('synRegKey').value;
        if (key == '') {
            CARBON.showWarningDialog('<fmt:message key="empty.key.field"/>');
            return false;
        }
        var registry;
        if (document.getElementById("config_reg").checked == true) {
            registry = 'conf';
        } else {
            registry = 'gov';
        }
        document.addressEndpointForm.action = 'saveDynamicEndpoint.jsp?registry='+registry
                +'&endpointType=addressEndpoint&regKey=' + key;
        document.addressEndpointForm.submit();
        return true;
    }

    function switchToSource(isAnonymous) {
        if (!isValidAddressORWSDLEndpoint(isAnonymous, 'address')) {
            return false;
        }
        document.addressEndpointForm.action = 'endpointSourceView.jsp?endpointType=addressEndpoint&retainlastbc=true';
        document.addressEndpointForm.submit();
        return true;
    }

    function showSaveAsForm(show) {
        var formElem = document.getElementById('saveAsForm');
        if (show) {
            formElem.style.display = "";
            var keyField = document.getElementById('synRegKey');
            if (keyField.value == '') {
                keyField.value = document.getElementById("endpointName").value;
            }
        } else {
            formElem.style.display = "none"
        }
    }




</script>

<div id="middle">
<h2><fmt:message key="address.endpoint"/></h2>

<div id="workArea">
<form id="addressEndpointForm" name="addressEndpointForm" action="" method="POST">
<table class="styledLeft">
<thead>
<tr>
    <th><span style="float: left; position: relative; margin-top: 2px;">
                            <fmt:message key="design.view.of.the.address.endpoint"/></span>

        <a class="icon-link"
           style="background-image: url(images/source-view.gif);"
           onclick="switchToSource('<%=isAnonymous%>');"
           href="#"><fmt:message key="switch.to.source.view"/></a>
    </th>
</tr>
</thead>
<tbody>
<tr>
<td>
<table class="normal-nopadding">
<tbody>

<tr style="<%=!isAnonymous?"":"display:none"%>">
    <td width="180px"><fmt:message key="endpointName"/> <span
            class="required">*</span></td>
    <td><input name="endpointName" id="endpointName"
               value="<%=addressEpName%>"
            <%=(!"".equals(addressEpName)) ? "disabled=\"disabled\"" : ""%>
               onkeypress="return validateText(event);"/>
        <input type="hidden" name="endpointName" value="<%=addressEpName%>"/>
    </td>
</tr>

<tr>
    <td class="leftCol-small"><fmt:message key="address"/><span class="required"> *</span>
    </td>
    <td><input id="address" name="address" type="text"
               value="<%=validAddressURL%>" size="75"/>
        <input id="testAddress" name="testAddress" type="button" class="button"
               onclick="testURL(document.getElementById('address').value)" value="<fmt:message key="test.url"/>"/>
    </td>
</tr>
<tr>
    <td><span id="_adv" style="float: left; position: relative;">
            <a class="icon-link"  onclick="javascript:showAdvancedOptions('');"
               style="background-image: url(images/down.gif);"><fmt:message key="show.advanced.options"/></a>
        </span>
    </td>
</tr>
</tbody>
</table>

<div id="_advancedForm" style="display:none">
<table class="normal-nopadding">
<tbody>
<tr>
    <td colspan="2" class="sub-header"><fmt:message key="message.content"/></td>
</tr>
<tr>
    <td width="180px"><fmt:message key="format"/></td>
    <td><select name="format">
        <option value="<%=formatOptions[0]%>" <%=isSoap11 ? "selected=\"selected\"" : ""%>>
            <fmt:message key="soap.1.1"/></option>
        <option value="<%=formatOptions[1]%>" <%=isSoap12 ? "selected=\"selected\"" : ""%>>
            <fmt:message key="soap.1.2"/></option>
        <option value="<%=formatOptions[2]%>" <%=isPox ? "selected=\"selected\"" : ""%>>
            <fmt:message key="plain.old.xml.pox"/></option>
        <option value="<%=formatOptions[3]%>" <%=isRest ? "selected=\"selected\"" : ""%>>
            <fmt:message key="representational.state.transer.rest.get"/></option>
        <option value="<%=formatOptions[4]%>" <%=isGet ? "selected=\"selected\"" : ""%>>
            <fmt:message key="get"/></option>
        <option value="<%=formatOptions[5]%>" <%=isformatDefault ? "selected=\"selected\"" : ""%>>
            <fmt:message
                    key="leave.as.is"/></option>
    </select>
    </td>
</tr>

<tr>
    <td><fmt:message key="optimize"/></td>
    <td><select name="optimize">
        <option value="<%=optimizeOptions[0]%>" <%=isSWA ? "selected" : ""%>>
            <fmt:message key="swa"/></option>
        <option value="<%=optimizeOptions[1]%>" <%=isMTOM ? "selected" : ""%>>
            <fmt:message key="mtom"/></option>
        <option value="<%=optimizeOptions[2]%>" <%=isOptimizeDefault ? "selected" : ""%>>
            <fmt:message key="leave.as.is"/></option>
    </select></td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message
            key="suspend"/></td>
</tr>
<tr>
    <td><fmt:message key="error.codes"/></td>
    <td><input type="text" id="suspendErrorCode" name="suspendErrorCode"
               value="<%=errorCode%>" size="75"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="intial.duration.millis"/></td>
    <td><input type="text" id="suspendDuration" name="suspendDuration"
               value="<%=suspendDurationOnFailure==0?"":suspendDurationOnFailure %>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="max.duration.millis"/></td>
    <td><input type="text" id="suspendMaxDuration" name="suspendMaxDuration"
               value="<%=maxDuration==0?"":maxDuration%>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="factor"/></td>
    <td><input type="text" id="factor" name="factor"
               value="<%=(factor==0)?"":factor%>"/>
    </td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message
            key="on.timedout"/></td>
</tr>
<tr>
    <td><fmt:message key="error.codes"/></td>
    <td><input type="text" id="retryErroCode" name="retryErroCode"
               value="<%=timeOutErrorCode%>" size="75"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="retry"/></td>
    <td><input type="text" id="retryTimeOut" name="retryTimeOut"
               value="<%=retryDelayTimeOut%>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="retry.delay.millis"/></td>
    <td><input type="text" id="retryDelay" name="retryDelay"
               value="<%=retryTimeOut%>"/>
    </td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message key="timeout"/></td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message key="action"/></div>
    </td>
    <td><select name="actionSelect" onchange="activateDurationField(this)">
        <option value="<%=actionOptions[0]%>" <%=isNeverTimeout ? "selected=\"selected\"" : ""%>>
            <fmt:message key="action.never.timeout"/></option>
        <option value="<%=actionOptions[1]%>" <%=isDiscardMessage ? "selected=\"selected\"" : ""%>>
            <fmt:message key="action.discard.message"/></option>
        <option value="<%=actionOptions[2]%>" <%=isFaultSequence ? "selected=\"selected\"" : ""%>>
            <fmt:message key="action.execute.fault.sequence"/></option>
    </select>
    </td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message key="duration.millis"/>
        </div>
    </td>
    <td><input id="actionDuration" type="text" name="actionDuration"
               value="<%=actionDuration%>"
        <%=actionDuration == 0 ? "disabled=\"disabled\"" : ""%>
    </td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message key="qos"/></td>
</tr>
<tr>
    <td><fmt:message key="ws.addressing"/></td>
    <td><input type="checkbox" id="wsAddressing" name="wsAddressing" value="wsAddressing"
        <%=isEnableAddressing ? "checked" : ""%>
    </td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message
                key="seperate.listener"/></div>
    </td>
    <td><input type="checkbox" id="sepListener" name="sepListener" value="sepListener"
        <%=isSepListener ? "checked=\"checked\"" : ""%>
    </td>
</tr>
<tr>
    <td><fmt:message key="ws.security"/></td>
    <td><input type="checkbox" id="wsSecurity" name="wsSecurity" value="wsSecurity"
            <%=isEnableWSSec ? "checked=\"checked\"" : ""%> />
    </td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message key="policy.key"/></div>
    </td>
    <td>
        <table class="normal">
            <tr>
                <td>
                    <input class="longInput" type="text" id="wsSecPolicyKeyID"
                           name="wsSecPolicyKeyID"
                           value="<%=secPolicy%>" readonly="true"/>
                </td>
                <td>
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       style="padding-left:20px;padding-right:20px"
                       onclick="showRegistryBrowser('wsSecPolicyKeyID', '/_system/config')"><fmt:message
                            key="registry.conf.keys"/></a>
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       style="padding-left:20px"
                       onclick="showRegistryBrowser('wsSecPolicyKeyID', '/_system/governance')"><fmt:message
                            key="registry.gov.keys"/></a>
                </td>
            </tr>
        </table>

    </td>
</tr>
<tr>
    <td><fmt:message key="ws.rm"/></td>
    <td><input type="checkbox" id="wsRM" name="wsRM" value="wsRM"
            <%=isEnableRM ? "checked=\"checked\"" : ""%> />
    </td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message
                key="policy.key"/></div>
    </td>
    <td>
        <table class="normal">
            <tr>
                <td><input class="longInput" type="text" id="wsrmPolicyKeyID"
                           name="wsrmPolicyKeyID"
                           value="<%=rmPolicy%>" readonly="true"/>
                </td>
                <td><a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       style="padding-left:20px;padding-right:20px"
                       onclick="showRegistryBrowser('wsrmPolicyKeyID', '/_system/config')"><fmt:message
                        key="registry.conf.keys"/></a>
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       style="padding-left:20px"
                       onclick="showRegistryBrowser('wsrmPolicyKeyID', '/_system/governance')"><fmt:message
                        key="registry.gov.keys"/></a>
                </td>
            </tr>
        </table>
    </td>
</tr>
</tbody>
</table>
</div>
<table class="normal-nopadding">
<tbody>

<tr>
    <td class="buttonRow" colspan="2">
        <input type="button" value="<fmt:message key="save"/>" class="button" name="save"
               onclick="javascript:submitEndpointData('<%=isAnonymous%>');"/>
        <%
            if (!isAnonymous)  {
        %>
            <input type="button" value="<fmt:message key="saveas"/>" class="button" name="save"
                   onclick="javascript:showSaveAsForm(true);"/>
        <%
            }
        %>
        <input type="button" value="<fmt:message key="cancel"/>" name="cancel" class="button"
               onclick="javascript:cancelEndpointData('<%=anonymouseOriginator%>');"/>
    </td>
</tr>
</tbody>

</table>
<div style="display:none;" id="saveAsForm">
    <p>&nbsp;</p>
    <table class="styledLeft">
        <thead>
        <tr>
            <th colspan="2">
                <span style="float:left; position:relative; margin-top:2px;"><fmt:message key="save.as.title"/></span>
            </th>
        </tr>
        </thead>
        <tbody>
        <tr>
            <td>
                <table class="normal">
                    <tr>
                        <td><fmt:message key="save.in"/></td>
                        <td><fmt:message key="gov.registry"/> <input type="radio" name="registry" id="gov_reg"
                                                       value="gov:" checked="checked"
                                                       onclick="document.getElementById('reg').innerHTML='gov:';"/>
                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                            <fmt:message key="config.registry"/> <input type="radio" name="registry" id="config_reg"
                                                   value="conf:"
                                                   onclick="document.getElementById('reg').innerHTML='conf:';"/>
                        </td>
                    </tr>
                    <tr>
                        <td>Key</td>
                        <td><span id="reg">gov:</span><input type="text" size="75" id="synRegKey"/></td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td class="buttonRow">
                <input type="button" class="button" value="<fmt:message key="save"/>" id="saveSynRegButton" onclick="javascript:submitDynamicEndpointData(); return false;"/>
                <input type="button" class="button" value="<fmt:message key="cancel"/>" id="cancelSynRegButton" onclick="javascript:showSaveAsForm(false); return false;">
            </td>
        </tr>
        </tbody>
    </table>
</div>
</td>
</tr>
</tbody>
</table>
</form>
</div>
</div>
<a name="registryBrowserLink"></a>
</fmt:bundle>
