<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.impl.builder.StAXOMBuilder" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="java.io.ByteArrayInputStream" %>
<%@ page import="java.util.ResourceBundle" %>
<%
    ResourceBundle bundle = ResourceBundle.getBundle("org.wso2.carbon.proxyadmin.ui.i18n.Resources",
            request.getLocale());
    String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(),
            session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient client = new EndpointAdminClient(cookie, url, configContext);

    String anonEpAction = request.getParameter("anonEpAction");
    String forwardTo = "";
    if (request.getParameter("cancelled") != null && "true".equals(request.getParameter("cancelled"))) {
        forwardTo = "index.jsp?header=" + session.getAttribute("header");
        // removes common attributes
        removeCommonSessionAttributes(session);
    } else {
        if (anonEpAction != null && !"".equals(anonEpAction) && "edit".equals(anonEpAction)) {
            // send path
            // sets the anonOriginator as anonEpHandler.jsp. This will be the page to which result should be returned
            session.setAttribute("anonOriginator", "registry_endpoint.jsp");
            session.setAttribute("header", request.getParameter("header"));
            session.setAttribute("epMode", "anon");
//            ProxyData pd = (ProxyData) session.getAttribute("proxy");
//            session.setAttribute("proxy", pd);
            // going to modify the existing EP
            String key = request.getParameter("key");
            String anonEpXML = client.getDynamicEndpoint(key);
            session.setAttribute("dynamicEprKey", key);
            if (anonEpXML != null && !"".equals(anonEpXML)) {
                try {
                    StAXOMBuilder builder = new StAXOMBuilder(new ByteArrayInputStream(anonEpXML.getBytes()));
                    OMElement elem = builder.getDocumentElement();
                    if ((elem = elem.getFirstElement()) != null) {
                        String localName = elem.getLocalName();
                        if ("address".equals(localName)) {
                            // current one is an address EP
                            forwardTo = "../endpoints/addressEndpoint.jsp";
                        } else if ("wsdl".equals(localName)) {
                            // current one is an wsdl EP
                            forwardTo = "../endpoints/WSDLEndpoint.jsp";
                        } else if ("failover".equals(localName)) {
                            // current one is an failover EP
                            forwardTo = "../endpoints/failOverEndpoint.jsp";
                        } else if ("loadbalance".equals(localName)) {
                            // current one is an loadBalance EP
                            forwardTo = "../endpoints/loadBalanceEndpoint.jsp";
                        } else if ("default".equals(localName)) {
                            forwardTo = "../endpoints/defaultEndpoint.jsp";
                            session.setAttribute("regEpName", key);
                        }
                    }
                } catch (XMLStreamException e) {
                    // todo - handle error
                }
                forwardTo = forwardTo + "?toppage=false";
                session.setAttribute("anonEpXML", anonEpXML);
            }
        } else {
            // return path
            String anonEpXML = (String) session.getAttribute("anonEpXML");
            String key = (String) session.getAttribute("dynamicEprKey");
            // the user may have cancelled the operation and therefore the anonEpXML may be null as well
            if (anonEpXML != null && !"".equals(anonEpXML) && key != null) {
                client.updateDynamicEndpoint(key, anonEpXML);
            }
            forwardTo = "index.jsp?header=" + session.getAttribute("header") + "&fromdesign=true";
            removeCommonSessionAttributes(session);
        }
    }
%>

<%!
    void removeCommonSessionAttributes(HttpSession session) {
        session.removeAttribute("dynamicEprKey");
        session.removeAttribute("anonOriginator");
        session.removeAttribute("epMode");
        session.removeAttribute("anonEpXML");
        session.removeAttribute("header");
    }
%>

<script type="text/javascript">
    window.location.href = '<%=forwardTo%>';
</script>
